<link rel="import" href="../../bower_components/polymer/polymer-element.html">
<link rel="import" href="dez-inline-items.html">

<dom-module id="dez-sources-selector">
  <template>
    <style>
    </style>
    <dez-inline-items id="items" items="[[_items]]"></dez-inline-items>
  </template>

  <script>

  class DezSourcesSelector extends Polymer.Element {

    static get is() { return 'dez-sources-selector'; }

    /**
    * Fired when an item is selected
    *
    * @event new-source-selected
    */

    set sources (sources) {
      let images = []
      if (sources.images && sources.images.length > 0) {
        images = sources.images.map(image => {
          return {
            name : image.name?image.name:"score",
            type : image.type,
            info : image.info,
            image : image.image,
            positions : image.positions
          }
        })
      }
      let audioImages = []
      if (sources.audios && sources.audios.length > 0) {
        sources.audios.forEach(audio => {
          if (audio.images && audio.images.length > 0) {
            audioImages = audioImages.concat(audio.images.map(image => {
              return {
                name : image.name?image.name:"wave",
                type : image.type,
                info : image.info?image.info:audio.info,
                image : image.image,
                positions : image.positions
              }
            }))
          }
        })
      }

      if (images.length + audioImages.length > 1) {
        this._items = images.concat(audioImages)
      } else {
        this._items = []
      }

    }

    ready () {
      super.ready()
      this.$.items.addEventListener('item-selected', event => {
        this.dispatchEvent(new CustomEvent('new-source-selected', {
          detail: {
            source : this._items[event.detail.index]
          }
        }))
      })
    }

  }

  window.customElements.define(DezSourcesSelector.is, DezSourcesSelector);

  </script>
</dom-module>
